<template>
  <div
    v-if="tableHeadings.length > 0"
    class="table">
    <section class="thead">
      <div class="tr">
        <!-- TODO: тут некоторое дерьмо с hidden
        нужна возможность динамически скрывать/показывать колонки из page -->
        <div
          v-for="(item, index1) in tableHeadings.filter(item => !item.hidden)"
          :key="`table-th-${index1}`"
          class="th"
          :class="`_${item.name}${!item.title ? ' _empty' : ''} ${item.classes}`">
          <template v-if="item.sorting.has">
            <!-- Классы для направления сортировки: -sorting-up / -sorting-down -->
            <button
              class="table-button-sorting"
              :class="sortClasses[item.sorting.criteria]"
              @click="orderChange(item.sorting.criteria)">
              <span>{{ item.title }}</span>
              <img
                svg-inline
                src="~/assets/svg/redesign/sorting-none.svg">
              <img
                svg-inline
                src="~/assets/svg/redesign/sorting.svg">
            </button>
          </template>
          <template v-else>
            {{ item.title }}
          </template>
        </div>
      </div>
    </section>

    <!-- это слот для фильтров, которые стоят второй строкой в хедере -->
    <slot name="thead-filters"/>

    <section class="tbody">
      <div
        class="tr"
        v-for="(part, index3) in grid.data"
        :key="`part-1${index3}`"
        :class="{ '_has-image': part.img,
                  '-outdated': part.is_outdated,
                  '-expanded': isExpandedRow(part.item_id + Number(part.is_wholesale)) }">
        <div
          class="td"
          v-for="(item, index2) in tableHeadings"
          :key="`table-td-${index3}${index2}`"
          :class="`_${item.name} ${item.classes}`">
          <slot
            v-if="!item.hidden"
            :name="`unit-${item.name}`"
            :part="part"/>
        </div>
      </div>
    </section>

    <footer
      class="table-footer"
      v-if="grid.countShown && grid.count">
      <div class="count">Показано {{ grid.countShown | spacifyNumber }} из {{ grid.count | spacifyNumber }}</div>
      <button
        class="buttonMore"
        type="button"
        v-if="hasLazyLoad"
        @click="loadData();$ga('More','Click50')">
        Показать еще
      </button>
    </footer>
  </div>
</template>

<script>
import { has } from 'lodash-es';
import AppButton from '~/components/redesign/app-buttons/app-button';

export default {
  name: 'AppTable',
  components: {
    AppButton,
  },
  props: {
    value: {
      type: Array,
      default() {
        return [];
      },
    },
    tableHeadings: {
      type: Array,
      default() {
        return [];
      },
    },
    grid: {
      type: Object,
      default() { return {}; },
    },
    hasLazyLoad: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    sortClasses() {
      const fields = this.tableHeadings
        .filter(column => column.sorting && column.sorting.has && column.sorting.criteria)
        .reduce((acc, column) => { acc[column.sorting.criteria] = 'none'; return acc; }, {});

      if (has(fields, this.grid.order.field)) {
        fields[this.grid.order.field] = (this.grid.order.direction === 'asc' ? '-sorting-up' : '-sorting-down');
      }

      return fields;
    },
  },
  methods: {
    orderChange(field) {
      let direction = 'asc';

      if (field === this.grid.order.field) {
        direction = this.grid.order.direction === 'asc' ? 'desc' : 'asc';
      }

      this.$emit('order-change', {
        field,
        direction,
      });
    },
    isExpandedRow(id) {
      return this.value.includes(id);
    },
    loadData() {
      this.$emit('load-data');
    },
  },
};
</script>

<style lang="postcss">
  /* autoprefixer: off */

  /* Стили для блоков с инфой о продавце */
  @import '~/assets/css/components/seller-info.css';

  /* Стили для всех таблицы */
  @import "~/assets/css/components/app-table-basic.css";

  /* Стили для таблицы популярных запросов */
  @import "~/assets/css/components/table-search-by-number-top.css";

  /* Стили для таблицы предложений */
  .table.tableMain {
    .th, .td {
      &._names {
        grid-area: names;
        border-bottom: none;
      }

      &._comment {
        display: none;
        grid-area: comment;
        padding: 0 2.5rem;
        border-top: none;
      }

      &._createdAd {
        grid-area: createdAd;
      }

      &._delivery {
        grid-area: delivery;
      }

      &._sellerBasic {
        grid-area: sellerBasic;
        // padding-bottom: 0;
      }

      &._sellerAdditional {
        display: none;
        grid-area: sellerAdditional;
        padding-top: 0;
        padding-bottom: 0;
        border-top: none;
      }

      &._price {
        grid-area: price;
      }

      &._buttonsCall {
        display: none;
        grid-area: buttonsFirst;
        padding-bottom: 0;
        padding-top: 0;
        padding-right: 1.5rem;
        border-top: none;
      }

      &._buttonsScl {
        display: none;
        grid-area: buttonsScl;
        padding-top: 0;
        padding-bottom: 0;
        padding-right: 1.5rem;
        border-top: none;
      }

      &._buttonsOrder {
        grid-area: buttonsLast;
        // grid-area: buttonsFirst;
        // padding-bottom: 0;
      }
    }

    .thead .tr {
      grid-template-rows: auto 0 0;
    }

    .th._comment,
    .th._sellerAdditional,
    .th._buttonsCall,
    .th._buttonsScl {
      display: none;
    }

    .linkNames {
      display: block;
      .row {
        display: inline-flex;
      }
      .svg {
        margin-top: 0.125rem;
        margin-left: 0.5rem;
      }
    }

    .sellerOutdated {
      display: flex;
      flex-direction: column;
      color: var(--error-color);

      .svg {
        display: block;
        margin-bottom: 0.5rem;
        width: 1.25rem;
        height: 1.25rem;
        fill: var(--error-color);
      }
    }

    .tr.-outdated {
      background-color: var(--bg-outdated-data);

      .__hide-shadow:after {
        background-image: var(--linear-gradient-outdated);
      }

      .sellerInfoTable {
        background-color: transparent;
      }

    }

    @media screen and (min-width: 981px) {
      .tr {
        grid-template-columns: minmax(auto, 1fr) 7rem 9.25rem 17.75rem 10.25rem 15rem;
        grid-template-rows: auto;
        grid-template-areas: "names createdAd delivery sellerBasic price buttonsLast"
      }

      .row {
        display: flex;
        align-items: stretch;
        padding-bottom: 0.375rem;
      }

      .buttonFilters {
        display: none;
      }

      .buttonOrder,
      .linkAsButton {
        padding: 0 0.875rem;
        width: 100%;
        font-size: 0.75rem;
      }

      .buttonCart {
        font-size: 0;
      }

      .sellerAdditionalInfo {
        display: block;
        padding: 1.25rem 0;
        width: 100%;
        border-top: 1px solid var(--border-color-main);

        .paragraph {
          padding-top: 0.625rem;
        }
      }

      .sellerActions {
        display: flex;
        flex-direction: column;
        align-items: flex-end;

        .sclContacts {
          margin: 1rem 0 0;
        }

        .buttonCircular {
          display: none;
        }

        .appWidgetChat,
        .buttonCall {
          width: 100%;
          margin-bottom: 0.75rem;
        }
      }

      .sellerContacts {
        .appWidgetChat {
          display: none;
        }
      }
    }

    @media (min-width: 981px) and (max-width: 1200px) {
      .tr {
        grid-template-columns:
                minmax(10rem, 0.8fr)
                0.65fr 0.6fr 15.5rem minmax(6rem, 0.8fr) 10rem;
      }

      .th, .td {
        font-size: 0.875rem;
        &:first-of-type {
          padding-left: 1rem;
        }
      }

      .th._names,
      .td._names {
        .table-button-sorting > span {
          max-height: 3.5rem;
          overflow: hidden;
        }
        .row {
          flex-direction: column;
          .dot {
            display: none;
          }
        }
      }

      .th._delivery {
        .table-button-sorting > span {
          max-height: 1.25rem;
          max-width: 2rem;
          overflow: hidden;
        }
      }

      .td._buttonsCall,
      .td._buttonsOrder,
      .td._buttonsScl {
        padding-right: 1rem;
      }

      .td._buttonsScl {
        padding: 0 0.875rem 1rem;
        background-color: var(--bg-dark);
      }

      .buttonOrder,
      .linkAsButton {
        font-size: 0.875rem;
      }

      .buttonCart {
        width: 100%;
        font-size: 0.875rem;

        .svgInBasket {
          margin-bottom: -1px;
          margin-left: 0.25rem;
          width: 0.75rem;
          height: auto;
          fill: var(--fill-main);
        }

        .svgBasket {
          display: none;
        }
      }

      .sellerActions {
        .row {
          flex-direction: column;
        }
      }
    }

    @media screen and (max-width: 980px) {
      .tr {
        position: relative;
        /* ширина таблицы минимум - 57.5rem */
        grid-template-columns: 6.25rem 1fr;
        grid-template-areas:
                "createdAd delivery"
                "names names"
                "price price"
                "sellerBasic sellerBasic"
                "buttonsFirst buttonsFirst";

        &.-outdated {
          grid-template-columns: 100%;
          grid-template-areas:
                  "createdAd" "delivery" "names" "price"
                  "sellerBasic" "buttonsFirst";

          .sellerOutdated {
            padding-bottom: 0.875rem;
          }

          .__hide-shadow:after {
            background-image: var(--linear-gradient-outdated);
          }
        }
      }

      .td {
        /*это стили для того, чтобы в мобилке кликать на всю карточку для раскрытия*/
        /*z-index: 1 - то, что находится на заднем фоне*/
        /*z-index: 2 - это кнопка раскрытия*/
        /*z-index: 3 - то, что находится выше кнопки раскрытия и должно быть кликабельно*/
        position: relative;
        z-index: 1;

        &._sellerBasic,
        &._buttonsOrder {
          z-index: 3;
        }

        &._buttonExpandedRow {
          display: none;
          position: absolute;
          z-index: 2;
          top: 0;
          left: 0;
          width: 100%;
          height: 100%;
        }
      }

      .td._comment,
      .td._buttonsScl {
        display: none;
        padding: 0;
      }

      .td._createdAd {
        font-size: 0.875rem;
      }

      .td._names {
        padding: 0.625rem 0 0 0;
        font-size: 1rem;

        .buttonCircular {
          display: none;
        }

        .__bold {
          font-size: 1.125rem;
        }
      }

      .td._buttonsOrder {
        grid-area: buttonsFirst;

        .sellerActions {
          display: flex;
          flex-direction: column-reverse;
          margin: 0;
          padding: 1.25rem 0;

          .row {
            display: flex;
            width: 100%;
          }

          .button {
            margin: 0;
            padding: 0;
            width: 100%;
          }

          .sclContacts {
            margin-bottom: 1rem;
          }
        }
      }

      .td._buttonsCall {
        display: none;
        grid-area: buttonsLast;
        padding: 0;

        .sellerActions {
          display: flex;
          margin: 0 -1.375rem;
          padding: 1.25rem 0.875rem 0 0.875rem;
          box-shadow: inset 0 1px 1px rgba(0, 0, 0, .1), inset 0 2px 0 1px var(--bg-dark);

          .buttonCall,
          .appWidgetChat {
            margin: 0 0.5rem;
            padding: 0;
            width: 100%;
          }
        }
      }

      .row {
        padding-bottom: 0.25rem;
      }

      .buttonExpandedRow {
        display: block;
        margin: 0.5rem 0 -0.5rem 0;

        .buttonCircular {
          position: absolute;
          z-index: 2;
          top: 0;
          left: 0;
          width: 100%;
          height: 100%;
          border-radius: 0;
          opacity: 0;
        }

        .buttonIsMobile {
          display: none;
        }
      }

      .buttonOrder,
      .buttonCart,
      .linkAsButton {
        font-size: 1rem;
      }

      .buttonCart {
        .svgBasket {
          display: inline-block;
          margin-right: 0.25rem;
          margin-bottom: -0.125rem;
        }

        .svgInBasket {
          margin-bottom: -0.125rem;
          margin-left: 0.25rem;
          width: 1rem;
          height: auto;
          fill: var(--fill-main);
        }
      }

      .sellerAdditionalInfo {
        padding: 1.25rem 0 0 0;
      }

      .sellerContacts {
        .sclContacts {
          flex-wrap: wrap;
          align-items: center;
          padding-top: 1.25rem;

          &-item {
            margin-bottom: 0.75rem;
          }
        }

        .appWidgetChat {
          display: none;
        }
      }

      .sellerQuantity {
        font-size: 0.875rem;
      }

      .sellerPrice {
        padding: 0.625rem 0 0 0;
      }

      .sellerOutdated {
        flex-direction: row;

        .svg {
          margin: 0 0.5rem 0 0;
        }
      }

      .linkNames .svg {
        display: none;
      }
    }
  }

  /* Стили для таблицы шин */
  .table.tableWheelsTyres {
    .th, .td {
      &._img {
        grid-area: img;
      }
      &._manufacturer {
        grid-area: manufacturer;
      }
      &._model {
        grid-area: model;
      }
      &._size {
        grid-area: size;
      }
      &._type {
        grid-area: type;
      }
      &._price {
        grid-area: price;
        align-items: flex-end;
      }
      &._actions {
        grid-area: actions;
      }
    }

    .picture {
      padding-top: 5.375rem;
      background-color: var(--bg-lightest);

      .svg {
        width: 2.5rem;
        height: auto;
        fill: var(--fill-light);
      }
    }

    @media screen and (min-width: 981px) {
      .tr {
        grid-template-columns:
          6.5rem 1fr 1fr 0.85fr 0.65fr 1fr 12rem;
        grid-template-areas: "img manufacturer model size type price actions";
      }

      .td {
        display: flex;
        flex-direction: column;
        justify-content: center;
      }

      .td._img {
        padding: 0;
        border-right: 1px solid var(--border-color-main);
      }

      .td._price {
        font-size: 1.5rem;
        font-weight: var(--font-weight-bold);
        text-align: right;
      }
    }

    @media screen and (max-width: 980px) {
      .tr {
        grid-template-columns: 1fr 6.5rem;
        grid-template-rows: auto;
        grid-template-areas: "manufacturer img" "model img" "size img" "type img" "price price" "actions actions";
      }
      .td._manufacturer {
        font-size: 1.125rem;
        font-weight: var(--font-weight-bold);
      }
      .td._model {
        padding-bottom: 0.375rem;
        font-size: 1.125rem;
        font-weight: var(--font-weight-bold);
      }
      .td._type {
        padding-bottom: 0.375rem;
      }
      .td._price {
        padding-bottom: 1.25rem;
        font-size: 1.5rem;
        font-weight: var(--font-weight-bold);
      }

      .td._img {
        padding-left: 1rem;
      }
    }
  }

  /* Стили для таблицы загрузок прайсов и таблицы шаблонов */
  .table.tablePriceUpload,
  .table.tablePriceTemplate,
  .table.tableUploadHistory {
    .th, .td {
      &._number {
        grid-area: number;
      }
      &._createdAd {
        grid-area: createdAd;
      }
      &._name {
        grid-area: name;
      }
      &._template {
        grid-area: template;
      }
      &._active {
        grid-area: active;
      }
      &._listUpload {
        grid-area: listUpload;
      }
      &._format {
        grid-area: format;
      }
      &._typeUpload {
        grid-area: typeUpload;
      }
      &._typePart {
        grid-area: typePart;
      }
      &._link {
        grid-area: link;
      }
      &._shop {
        grid-area: shop;
      }
      &._fileName {
        grid-area: fileName;
      }
      &._status {
        grid-area: status;
      }
      &._errors {
        grid-area: errors;
      }

      &._actions {
        grid-area: actions;
        padding-top: 0.25rem;
        padding-bottom: 0.25rem;
      }
    }

    .listInfo {
      &-item {
        display: block;
        .buttonMore {
          font-size: inherit;
        }
      }
    }

    .buttonIcon {
      display: block;
      padding: 0;
      margin: 0.5rem;
      border: none;
      background: none;
      box-shadow: none;
      outline: none;
      cursor: pointer;
      .svg {
        fill: var(--fill-main);
        opacity: 0.7;
        transition: 0.1s opacity var(--transition-easeOutQuad);
      }
      &:hover, &:active, &:focus {
        .svg {
          opacity: 1;
        }
      }
    }

    @media screen and (min-width: 981px) {
      .thead > .tr > .th {
        align-items: flex-start;
        padding-left: 1rem;
        padding-right: 1rem;
      }

      .tr {
        .td {
          justify-content: center;
          padding-left: 1rem;
          padding-right: 1rem;
          line-height: 1.4;
        }
      }
    }
  }

  .table.tablePriceUpload {
    @media screen and (min-width: 981px) {
      .tr {
        grid-template-columns: 4rem 0.8fr 1.5fr 1fr 1fr 1fr 1.5fr 4rem;
        grid-template-areas: "number createdAd name template typeUpload typePart link actions";
      }
    }
  }

  .table.tablePriceTemplate {
    @media screen and (min-width: 981px) {
      .tr {
        grid-template-columns: 4rem 0.6fr 0.8fr 6rem 0.8fr 1fr 1fr 4rem;
        grid-template-areas: "number createdAd name active typePart format listUpload actions";
      }
    }
  }

  .table.tableUploadHistory {
    @media screen and (min-width: 981px) {
      .tr {
        grid-template-columns: 4rem 7.75rem 1fr 1fr 0.7fr 0.7fr 1fr;
        grid-template-areas: "number createdAd fileName shop typeUpload status errors";
      }
    }
  }

  /*только для Mozilla Firefox*/
  @-moz-document url-prefix() {
    .table {
      .th, .td {
        max-height: none;
      }
    }
  }
</style>
